<#
#
# simple script to check registry for language pack installed
# niall brady 2016/5/4
# ver 0.1 only checks for one LP
#>
param(
[string]$OSDISK
)

# Close the Task Sequence UI temporarily
# if you want to test this outside of a task sequence then rem out the two lines below
$TSProgressUI = New-Object -COMObject Microsoft.SMS.TSProgressUI
$TSProgressUI.CloseProgressDialog()

Write-Host "Attempting to mount default registry hive on drive: " $OSDISK
& REG LOAD HKLM\Defuser $OSDISK\Users\Default\NTUSER.DAT

Write-Host "Checking for LP installed..."
if (test-path 'HKLM:\Defuser\Control Panel\International\User Profile\')
{
write-host "reg key was found!"
Push-Location 'HKLM:\Defuser\Control Panel\International\User Profile\'
$lp=(get-ItemProperty 'HKLM:\Defuser\Control Panel\International\User Profile\').Languages
write-host "found the following Language Pack installed:" $lp

#set the task sequence variable for the detected lp
$tsenv = New-Object -COMObject Microsoft.SMS.TSEnvironment
$tsenv.Value("DetectedLP") = "$lp"
Pop-Location
$unloaded = $false
$attempts = 0
while (!$unloaded -and ($attempts -le 5)) {
  [gc]::Collect() # necessary call to be able to unload registry hive
  & REG UNLOAD HKLM\Defuser
  $unloaded = $?
  $attempts += 1
}
if (!$unloaded) {
  Write-Warning "Unable to dismount default user registry hive at HKLM\DEFAULT - manual dismount required"
}
}

else {write-host "reg key not found"

#set the task sequence variable to default

$tsenv = New-Object -COMObject Microsoft.SMS.TSEnvironment
$tsenv.Value("DetectedLP") = "en-US"

}



